Bug 675196 - Missing includes in devel package
Summary: Missing includes in devel package
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: nss-util
Version: 14
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Elio Maldonado Batiz
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 676387
TreeView+ depends on / blocked
 
Reported: 2011-02-04 15:31 UTC by Stefan Berger
Modified: 2011-03-07 20:56 UTC (History)
3 users (show)

Fixed In Version: nss-3.12.9-8.fc13
Doc Type: Bug Fix
Doc Text:
Clone Of:
: 676387 (view as bug list)
Environment:
Last Closed: 2011-02-06 20:20:37 UTC


Attachments (Terms of Use)

Description Stefan Berger 2011-02-04 15:31:42 UTC
Description of problem:

The package nss-util-devel is missing at least one include file:

/usr/include/nss3/seccomon.h:51:21: fatal error: prtypes.h: No such file or directory

Version-Release number of selected component (if applicable):

#rpm -q --whatprovides /usr/include/nss3/seccomon.h 
nss-util-devel-3.12.9-1.fc14.x86_64

Comment 1 Elio Maldonado Batiz 2011-02-04 16:51:19 UTC
prtypes.h is part is provided by nspr-devel
# rpm -ql nspr-devel | grep prtypes.h
/usr/include/nspr4/prtypes.h

which is required by nss-util-devel
#rpm -q --whatrequires nspr-devel
xulrunner-devel-1.9.2.13-5.fc14.x86_64
nss-util-devel-3.12.9-1.fc14.x86_64
nss-softokn-devel-3.12.9-1.fc14.x86_64
nss-devel-3.12.9-1.fc14.x86_64

Comment 2 Stefan Berger 2011-02-04 16:59:15 UTC
Let me be more specific:

In file included from /usr/include/nss3/blapit.h:46:0,
                 from /usr/include/nss3/blapi.h:45,
                 from test.c:52:
/usr/include/nss3/seccomon.h:51:21: fatal error: prtypes.h: No such file or directory

seccommon.h shows this here:

[...]
#ifndef _SECCOMMON_H_
#define _SECCOMMON_H_

#include "utilrename.h"
#include "prtypes.h"

[...]

I believe it expects prtypes.h to be found in nss3, no?

Comment 3 Elio Maldonado Batiz 2011-02-04 17:24:14 UTC
No, it actually expects the file to be found in nspr4, as in
/usr/include/nspr4/prtypes.h

Comment 4 Stefan Berger 2011-02-04 17:28:52 UTC
In a next step I added -I/usr/include/nspr4 to gcc for inclusion of the needed path leads to:

/usr/include/nss3/blapi.h:47:21: fatal error: alghmac.h: No such file or directory

I cannot 'find | grep alghmac' in /usr/include...

Once the #include of this file is commented, I can compile. It would be great if the development packages could be fixed.

Comment 5 Elio Maldonado Batiz 2011-02-04 18:00:07 UTC
/usr/include/nss3/blapi.h is a private header of the freebl library in nss-soften-devel and nss-util and its nss-util-devel do not depend on anything in the rest of nss or nss-softokn. They are the lower level common utilities required both nss and nss-softoken. nss depends on nss-softokn and nss-util
The freebl headers are as a rule private to the crypto module, with very few limited exceptional cases.

Comment 6 Stefan Berger 2011-02-04 18:19:05 UTC
Assuming I wanted to link against -lfreebl and use the function RNG_RNGInit(). Where am I going to get its prototype from other than including nss3/blapi.h ?

Comment 7 Elio Maldonado Batiz 2011-02-04 18:40:16 UTC
nss-softoken-freebl-devel (subpackage of nss-softokn) provides you that header. 
#rpm -ql nss-softokn-freebl-devel
/usr/include/nss3/blapi.h
/usr/lib64/libfreebl.a

Comment 8 Stefan Berger 2011-02-04 18:52:03 UTC
I know that. See above in comment 4 the error that I am getting when including blapi.h. alghmac.h is missing.

Comment 9 Elio Maldonado Batiz 2011-02-04 19:19:07 UTC
I see alghmac.h listed as one of freebl's private exports in mozilla/security/nss/lib/freebl/maninifest.mn
...
PRIVATE_EXPORTS = \
	alghmac.h \
...
It does show up in mozilla/dist/nss/private. 
It does not appear listed in the nss-softokn.spec (or nss.spec) so it doesn't copied to /usr/include/nss3 along with other private headers. This may be fixable. 

Could you do me a favor? Manually copy alghmac.h into /usr/include/nss3 and try to compile your project. Before I add it to the list let me see what else it pulls in. I would hate to trigger a chain reaction of headers being brought in.

Comment 10 Elio Maldonado Batiz 2011-02-04 21:10:05 UTC
alghmac.h doesn't include anything else and that's promising
Let me know if these scratch builds of nss-softokn and nss
http://koji.fedoraproject.org/koji/taskinfo?taskID=2762816
http://koji.fedoraproject.org/koji/taskinfo?taskID=2762830
work for you.

Comment 11 Stefan Berger 2011-02-04 21:38:01 UTC
Installing

nss-softokn-freebl-3.12.9-2.fc14.x86_64.rpm
nss-softokn-freebl-devel-3.12.9-2.fc14.x86_64.rpm

from these builds did the trick for me.

Comment 12 Fedora Update System 2011-02-04 22:28:53 UTC
nss-softokn-3.12.9-2.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/nss-softokn-3.12.9-2.fc14

Comment 13 Stefan Berger 2011-02-05 00:09:03 UTC
Unless done anyway, please submit

nss-softokn-freebl-3.12.9-2.fc14.x86_64.rpm
nss-softokn-freebl-devel-3.12.9-2.fc14.x86_64.rpm

rather than (only)

nss-softokn-3.12.9-2.fc14 

as an update.

Comment 14 Elio Maldonado Batiz 2011-02-05 00:22:21 UTC
nss-softokn-freebl and nss-softokn-freebl-devel can't be submitted by themselves. They are mere sub-packages of the nss-softokn package so it's the latter that gets submitted.

Comment 15 Fedora Update System 2011-02-05 22:21:40 UTC
nss-softokn-3.12.9-2.fc14 has been pushed to the Fedora 14 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update nss-softokn'.  You can provide feedback for this update here: https://admin.fedoraproject.org/updates/nss-softokn-3.12.9-2.fc14

Comment 16 Fedora Update System 2011-02-06 20:20:33 UTC
nss-softokn-3.12.9-2.fc14 has been pushed to the Fedora 14 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 17 Fedora Update System 2011-02-25 00:23:39 UTC
nss-softokn-3.12.9-6.fc15,nss-3.12.9-13.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/nss-softokn-3.12.9-6.fc15,nss-3.12.9-13.fc15

Comment 18 Fedora Update System 2011-02-25 16:13:21 UTC
nss-softokn-3.12.9-4.fc14,nss-3.12.9-8.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/nss-softokn-3.12.9-4.fc14,nss-3.12.9-8.fc14

Comment 19 Fedora Update System 2011-02-27 21:34:37 UTC
Package nss-3.12.9-8.fc13,nss-softokn-3.12.9-5.fc13,nss-util-3.12.9-1.fc13,nspr-4.8.7-1.fc13:
* should fix your issue,
* was pushed to the Fedora 13 updates-testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing nss-3.12.9-8.fc13,nss-softokn-3.12.9-5.fc13,nss-util-3.12.9-1.fc13,nspr-4.8.7-1.fc13'
as soon as you are able to, then reboot.
Please go to the following url:
https://admin.fedoraproject.org/updates/nss-3.12.9-8.fc13,nss-softokn-3.12.9-5.fc13,nss-util-3.12.9-1.fc13,nspr-4.8.7-1.fc13
then log in and leave karma (feedback).

Comment 20 Fedora Update System 2011-03-01 04:22:46 UTC
nss-softokn-3.12.9-5.fc14, nss-3.12.9-8.fc14 has been pushed to the Fedora 14 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 21 Fedora Update System 2011-03-03 03:22:30 UTC
nss-softokn-3.12.9-7.fc15, nss-3.12.9-13.fc15 has been pushed to the Fedora 15 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 22 Fedora Update System 2011-03-07 20:55:31 UTC
nss-3.12.9-8.fc13, nss-softokn-3.12.9-5.fc13, nss-util-3.12.9-1.fc13, nspr-4.8.7-1.fc13 has been pushed to the Fedora 13 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.